;===========================================================================================
; nddraw.inc    AsmGges France                                  http://www.chez.com/asmgges/
; 14/10/2006 Dfinitions macros equates et structures Directx
;===========================================================================================

;Fonctions DirectDraw
 %define  DD_QueryInterface          000h
 %define  DD_AddRef                  004h
 %define  DD_Release                 008h
 %define  DD_Compact                 00Ch
 %define  DD_CreateClipper           010h
 %define  DD_CreatePalette           014h
 %define  DD_CreateSurface           018h
 %define  DD_DuplicateSurface        01Ch
 %define  DD_EnumDisplayModes        020h
 %define  DD_EnumSurfaces            024h
 %define  DD_FlipToGDISurface        028h
 %define  DD_GetCaps                 02Ch
 %define  DD_GetDisplayMode          030h
 %define  DD_GetFourCCCodes          034h
 %define  DD_GetGDISurface           038h
 %define  DD_GetMonitorFrequency     03Ch
 %define  DD_GetScanLine             040h
 %define  DD_GetVerticalBlankStatus  044h
 %define  DD_Initialize              048h
 %define  DD_RestoreDisplayMode      04Ch
 %define  DD_SetCooperativeLevel     050h
 %define  DD_SetDisplayMode          054h
 %define  DD_WaitForVerticalBlank    058h
 %define  DD_GetAvailableVidMem      05Ch
 %define  DD_GetSurfaceFromDC        060h
 %define  DD_RestoreAllSurfaces      064h
 %define  DD_TestCooperativeLevel    068h
 %define  DD_GetDeviceIdentifier     06Ch
 %define  DD_StartModeTest           070h
 %define  DD_EvaluateMode            074h
 
;Fonctions DirectDrawSurface
 %define  DDS_QueryInterface         000h
 %define  DDS_AddRef                 004h
 %define  DDS_Release                008h
 %define  DDS_AddAttachedSurface     00Ch
 %define  DDS_AddOverlayDirtyRect    010h
 %define  DDS_Blt                    014h
 %define  DDS_BltBatch               018h
 %define  DDS_BltFast                01Ch
 %define  DDS_DeleteAttachedSurface  020h
 %define  DDS_EnumAttachedSurfaces   024h
 %define  DDS_EnumOverlayZOrders     028h
 %define  DDS_Flip                   02Ch
 %define  DDS_GetAttachedSurface     030h
 %define  DDS_GetBltStatus           034h
 %define  DDS_GetCaps                038h
 %define  DDS_GetClipper             03Ch
 %define  DDS_GetColorKey            040h
 %define  DDS_GetDC                  044h
 %define  DDS_GetFlipStatus          048h
 %define  DDS_GetOverlayPosition     04Ch
 %define  DDS_GetPalette             050h
 %define  DDS_GetPixelFormat         054h
 %define  DDS_GetSurfaceDesc         058h
 %define  DDS_Initialize             05Ch
 %define  DDS_IsLost                 060h
 %define  DDS_Lock                   064h
 %define  DDS_ReleaseDC              068h
 %define  DDS_Restore                06Ch
 %define  DDS_SetClipper             070h
 %define  DDS_SetColorKey            074h
 %define  DDS_SetOverlayPosition     078h
 %define  DDS_SetPalette             07Ch
 %define  DDS_Unlock                 080h
 %define  DDS_UpdateOverlay          084h
 %define  DDS_UpdateOverlayDisplay   088h
 %define  DDS_UpdateOverlayZOrder    08Ch
 %define  DDS_GetDDInterface         090h
 %define  DDS_PageLock               094h
 %define  DDS_PageUnlock             098h
 %define  DDS_SetSurfaceDesc         09Ch
 %define  DDS_SetPrivateData         0A0h
 %define  DDS_GetPrivateData         0A4h
 %define  DDS_FreePrivateData        0A8h
 %define  DDS_GetUniquenessValue     0ACh
 %define  DDS_ChangeUniquenessValue  0B0h
 %define  DDS_SetPriority            0B4h
 %define  DDS_GetPriority            0B8h
 %define  DDS_SetLOD                 0BCh
 %define  DDS_GetLOD                 0C0h 

;Fonctions DirectDrawClipper
 %define  DDC_QueryInterface         000h
 %define  DDC_AddRef                 004h
 %define  DDC_Release                008h
 %define  DDC_GetClipList            00Ch
 %define  DDC_GetHWnd                010h
 %define  DDC_Initialize             014h
 %define  DDC_IsClipListChanged      018h
 %define  DDC_SetClipList            01Ch
 %define  DDC_SetHWnd                020h

;DirectDrawPalette
 %define  DDP_QueryInterface         000h
 %define  DDP_AddRef                 004h
 %define  DDP_Release                008h
 %define  DDP_GetCaps                00Ch
 %define  DDP_GetEntries             010h
 %define  DDP_Initialize             014h
 %define  DDP_SetEntries             018h

;DirectDrawColorControl
 %define  DDCC_QueryInterface        000h
 %define  DDCC_AddRef                004h
 %define  DDCC_Release               008h
 %define  DDCC_GetColorControls      00Ch
 %define  DDCC_SetColorControls      010h

;DirectDrawGammaControl
 %define  DDGC_QueryInterface        000h
 %define  DDGC_AddRef                004h
 %define  DDGC_Release               008h
 %define  DDGC_GetGammaRamp          00Ch
 %define  DDGC_SetGammaRamp          010h

;Equates directDraw;Equates directDraw
 %define  DDLOCK_WAIT                000000001h
 %define  DDSCL_FULLSCREEN           000000001h
 %define  DDSCL_EXCLUSIVE            000000010h
 %define  DDSCL_NORMAL               000000008h
 %define  DDSD_CAPS                  000000001h
 %define  DDSD_HEIGHT                000000002h
 %define  DDSD_WIDTH                 000000004h
 %define  DDSD_PITCH                 000000008h
 %define  DDSD_BACKBUFFERCOUNT       000000020h
 %define  DDSCAPS_BACKBUFFER         000000004h
 %define  DDSCAPS_COMPLEX            000000008h
 %define  DDSCAPS_FLIP               000000010h
 %define  DDSCAPS_OFFSCREENPLAIN     000000040h
 %define  DDSCAPS_PRIMARYSURFACE     000000200h
 %define  DDSCAPS_SYSTEMMEMORY       000000800h
 %define  DDBLT_KEYSRC               000008000h
 %define  DDBLT_WAIT                 001000000h
 %define  DDBLT_COLORFILL            000000400h
 %define  DDBLT_DDFX                 000000800h
 %define  DDFLIP_WAIT                000000001h
 %define  DDBLTFAST_NOCOLORKEY       000000000h
 %define  DDBLTFAST_SRCCOLORKEY      000000001h
 %define  DDBLTFAST_WAIT             000000010h
 %define  DDCKEY_SRCBLT              000000008h
 %define  DDPCAPS_8BIT               000000004h
 %define  DDPCAPS_ALLOW256           000000040h
 %define  DDERR_SURFACELOST          0887601C2h

;ddraw structures AsmGges

STRUC DDCOLORKEY
  .dwColorSpaceLowValue   RESD 1
  .dwColorSpaceHighValue  RESD 1
ENDSTRUC

STRUC DDPIXELFORMAT
  .dwSize                   RESD 1
  .dwFlags                  RESD 1
  .dwFourCC                 RESD 1

  .dwRGBBitCount:          
  .dwYUVBitCount:          
  .dwZBufferBitDepth:      
  .dwAlphaBitDepth:        
  .dwLuminanceBitCount:   
  .dwBumpBitCount           RESD 1

  .dwRBitMask:             
  .dwYBitMask:             
  .dwStencilBitDepth:     
  .dwLuminanceBitMask:     
  .dwBumpDuBitMask          RESD 1

  .dwGBitMask:             
  .dwUBitMask:             
  .dwZBitMask:             
  .dwBumpDvBitMask          RESD 1

  .dwBBitMask:             
  .dwVBitMask:             
  .dwStencilBitMask:       
  .dwBumpLuminanceBitMask   RESD 1

  .dwRGBAlphaBitMask:       
  .dwYUVAlphaBitMask:       
  .dwLuminanceAlphaBitMask: 
  .dwRGBZBitMask:           
  .dwYUVZBitMask            RESD 1
ENDSTRUC

STRUC DDSCAPS
  .dwCaps RESD 1
ENDSTRUC

STRUC DDSURFACEDESC
  .dwSize             RESD 1
  .dwFlags            RESD 1
  .dwHeight           RESD 1
  .dwWidth            RESD 1
 
  .lPitch:            
  .dwLinearSize       RESD 1
 
  .dwBackBufferCount  RESD 1
 
  .dwMipMapCount:     
  .dwZBufferBitDepth: 
  .dwRefreshRate      RESD 1
 
  .dwAlphaBitDepth    RESD 1
  .dwReserved         RESD 1
  .lpSurface          RESD 1
  .ddckCKDestOverlay  RESB DDCOLORKEY_size
  .ddckCKDestBlt      RESB DDCOLORKEY_size
  .ddckCKSrcOverlay   RESB DDCOLORKEY_size
  .ddckCKSrcBlt       RESB DDCOLORKEY_size
  .ddpfPixelFormat    RESB DDPIXELFORMAT_size
  .ddsCaps            RESB DDSCAPS_size
ENDSTRUC

STRUC DDBLTFX
  .dwSize                   RESD 1
  .dwDDFX                   RESD 1
  .dwROP                    RESD 1
  .dwDDROP                  RESD 1
  .dwRotationAngle          RESD 1
  .dwZBufferOpCode          RESD 1
  .dwZBufferLow             RESD 1
  .dwZBufferHigh            RESD 1
  .dwZBufferBaseDest        RESD 1
  .dwZDestConstBitDepth     RESD 1

  .dwZDestConst:             
  .lpDDSZBufferDest         RESD 1

  .dwZSrcConstBitDepth      RESD 1

  .dwZSrcConst:              
  .lpDDSZBufferSrc          RESD 1

  .dwAlphaEdgeBlendBitDepth RESD 1
  .dwAlphaEdgeBlend         RESD 1
  .dwReserved               RESD 1
  .dwAlphaDestConstBitDepth RESD 1

  .dwAlphaDestConst:         
  .lpDDSAlphaDest           RESD 1

  .dwAlphaSrcConstBitDepth  RESD 1

  .dwAlphaSrcCont:          
  .lpDDSAlphaSrc            RESD 1

  .dwFillColor:              
  .dwFillDepth:              
  .dwFillPixel:              
  .lpDDSPattern             RESD 1

  .ddckDestColorKey         RESB DDCOLORKEY_size
  .ddckSrcColorKey          RESB DDCOLORKEY_size
ENDSTRUC

;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================